From 524ff680819b0cc347032210cbf6e24389630a03 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 31 2020 01:29:12 +0000
Subject: [PATCH 1901/2232] Fix span placement on extern C++ type


---

diff --git a/gen/src/nested.rs b/gen/src/nested.rs
index bfe370c..d94d36d 100644
--- a/gen/src/nested.rs
+++ b/gen/src/nested.rs
@@ -133,6 +133,7 @@ mod tests {
             doc: Doc::new(),
             derives: Vec::new(),
             attrs: OtherAttrs::none(),
+            visibility: Token![pub](Span::call_site()),
             type_token: Token![type](Span::call_site()),
             name: Pair {
                 namespace: ns,
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 4fec02d..b6746ac 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -360,15 +360,25 @@ fn expand_cxx_type(ety: &ExternType) -> TokenStream {
         let field = format_ident!("_lifetime_{}", lifetime.ident);
         quote!(#field: ::std::marker::PhantomData<&#lifetime ()>)
     });
+    let repr_fields = quote! {
+        _private: ::cxx::private::Opaque,
+        #(#lifetime_fields,)*
+    };
+
+    let span = ident.span();
+    let visibility = &ety.visibility;
+    let struct_token = Token![struct](ety.type_token.span);
+    let extern_type_def = quote_spanned! {span=>
+        #visibility #struct_token #ident #generics {
+            #repr_fields
+        }
+    };
 
     quote! {
         #doc
         #attrs
         #[repr(C)]
-        pub struct #ident #generics {
-            _private: ::cxx::private::Opaque,
-            #(#lifetime_fields,)*
-        }
+        #extern_type_def
 
         unsafe impl #generics ::cxx::ExternType for #ident #generics {
             type Id = #type_id;
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 0d07fd0..77e7e64 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -74,6 +74,7 @@ pub struct ExternType {
     pub doc: Doc,
     pub derives: Vec<Derive>,
     pub attrs: OtherAttrs,
+    pub visibility: Token![pub],
     pub type_token: Token![type],
     pub name: Pair,
     pub generics: Lifetimes,
diff --git a/syntax/parse.rs b/syntax/parse.rs
index b8bf515..0fbdda2 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -426,6 +426,12 @@ fn parse_extern_type(
         },
     );
 
+    let visibility = Token![pub](match foreign_type.vis {
+        Visibility::Public(vis) => vis.pub_token.span,
+        Visibility::Crate(vis) => vis.crate_token.span,
+        Visibility::Restricted(vis) => vis.pub_token.span,
+        Visibility::Inherited => foreign_type.ident.span(),
+    });
     let type_token = foreign_type.type_token;
     let name = pair(namespace, &foreign_type.ident, cxx_name, rust_name);
     let generics = Lifetimes {
@@ -445,6 +451,7 @@ fn parse_extern_type(
         doc,
         derives,
         attrs,
+        visibility,
         type_token,
         name,
         generics,
@@ -630,7 +637,7 @@ fn parse_extern_verbatim(
 ) -> Result<Api> {
     |input: ParseStream| -> Result<Api> {
         let attrs = input.call(Attribute::parse_outer)?;
-        input.parse::<Visibility>()?;
+        let visibility: Visibility = input.parse()?;
         let type_token: Token![type] = match input.parse()? {
             Some(type_token) => type_token,
             None => {
@@ -686,7 +693,8 @@ fn parse_extern_verbatim(
         } else if lookahead.peek(Token![:]) || lookahead.peek(Token![;]) {
             // type Opaque: Bound2 + Bound2;
             parse_extern_type_bounded(
-                cx, attrs, type_token, ident, lifetimes, input, lang, trusted, namespace,
+                cx, attrs, visibility, type_token, ident, lifetimes, input, lang, trusted,
+                namespace,
             )
         } else {
             Err(lookahead.error())
@@ -751,6 +759,7 @@ fn parse_type_alias(
 fn parse_extern_type_bounded(
     cx: &mut Errors,
     attrs: Vec<Attribute>,
+    visibility: Visibility,
     type_token: Token![type],
     ident: Ident,
     generics: Lifetimes,
@@ -810,6 +819,12 @@ fn parse_extern_type_bounded(
         },
     );
 
+    let visibility = Token![pub](match visibility {
+        Visibility::Public(vis) => vis.pub_token.span,
+        Visibility::Crate(vis) => vis.crate_token.span,
+        Visibility::Restricted(vis) => vis.pub_token.span,
+        Visibility::Inherited => ident.span(),
+    });
     let name = pair(namespace, &ident, cxx_name, rust_name);
 
     Ok(match lang {
@@ -820,6 +835,7 @@ fn parse_extern_type_bounded(
         doc,
         derives,
         attrs,
+        visibility,
         type_token,
         name,
         generics,
diff --git a/tests/ui/deny_missing_docs.stderr b/tests/ui/deny_missing_docs.stderr
index df82b3b..55ae806 100644
--- a/tests/ui/deny_missing_docs.stderr
+++ b/tests/ui/deny_missing_docs.stderr
@@ -29,12 +29,10 @@ error: missing documentation for an associated constant
    |         ^^^^^^^^^^^^^^^^^^^
 
 error: missing documentation for a struct
- --> $DIR/deny_missing_docs.rs:9:1
-  |
-9 | #[cxx::bridge]
-  | ^^^^^^^^^^^^^^
-  |
-  = note: this error originates in an attribute macro (in Nightly builds, run with -Z macro-backtrace for more info)
+  --> $DIR/deny_missing_docs.rs:44:9
+   |
+44 |         pub type UndocumentedForeignType;
+   |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 
 error: missing documentation for a type alias
  --> $DIR/deny_missing_docs.rs:9:1

